apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ jenkins_name }}-config
  namespace: {{ namespace }}
data:
  hudson.plugins.git.GitSCM.xml: |
    <?xml version='1.1' encoding='UTF-8'?>
    <hudson.plugins.git.GitSCM_-DescriptorImpl plugin="git@3.9.1">
      <generation>1</generation>
      <globalConfigName>jenkins</globalConfigName>
      <globalConfigEmail>jenkins@{{ root_domain }}</globalConfigEmail>
      <createAccountBasedOnEmail>false</createAccountBasedOnEmail>
    </hudson.plugins.git.GitSCM_-DescriptorImpl>
  hudson.plugins.sonar.SonarGlobalConfiguration.xml: |
    <?xml version='1.1' encoding='UTF-8'?>
{% if sonarqube_api_address | default(False) %}
    <hudson.plugins.sonar.SonarGlobalConfiguration plugin="sonar@2.8">
      <installations>
        <hudson.plugins.sonar.SonarInstallation>
          <name>cicd</name>
          <serverUrl>{{ sonarqube_api_address | urlsplit('scheme') }}://{{ sonarqube_scanner.resources[0].data['username'] | default('admin') }}:{{ (sonarqube_scanner.resources[0].data['password'] | b64decode) | default('admin') }}@{{ sonarqube_api_address | urlsplit('hostname') }}:{{ sonarqube_api_address | urlsplit('port') }}/</serverUrl>
          <serverAuthenticationToken></serverAuthenticationToken>
          <mojoVersion></mojoVersion>
          <additionalProperties></additionalProperties>
          <additionalAnalysisProperties></additionalAnalysisProperties>
          <triggers>
            <skipScmCause>false</skipScmCause>
            <skipUpstreamCause>false</skipUpstreamCause>
            <envVar></envVar>
          </triggers>
        </hudson.plugins.sonar.SonarInstallation>
      </installations>
      <buildWrapperEnabled>false</buildWrapperEnabled>
      <dataMigrated>true</dataMigrated>
    </hudson.plugins.sonar.SonarGlobalConfiguration>
{% endif %}
  hudson.tasks.Mailer.xml: |
    <?xml version='1.1' encoding='UTF-8'?>
{% if smtp_relay | default(False) or smtps_address | default(False) or smtp_address | default(False) %}
    <hudson.tasks.Mailer_-DescriptorImpl plugin="mailer@1.21">
      <defaultSuffix>@{{ root_domain }}</defaultSuffix>
{% if smtp_relay | default(False) %}
      <smtpHost>{{ smtp_relay }}</smtpHost>
      <useSsl>{{ 'fals' if (smtp_port | default(25) | int == 25) else 'tru' }}e</useSsl>
{% elif smtps_address | default(False) %}
      <smtpHost>{{ smtps_address | urlsplit('hostname') }}</smtpHost>
      <useSsl>true</useSsl>
{% else %}
      <smtpHost>{{ smtp_address | urlsplit('hostname') }}</smtpHost>
      <useSsl>false</useSsl>
{% endif %}
      <charset>UTF-8</charset>
    </hudson.tasks.Mailer_-DescriptorImpl>
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
  jenkins.model.JenkinsLocationConfiguration.xml: |
    <?xml version='1.1' encoding='UTF-8'?>
    <jenkins.model.JenkinsLocationConfiguration>
      <adminAddress>address not configured yet &lt;nobody@nowhere&gt;</adminAddress>
      <jenkinsUrl>https://jenkins.{{ root_domain }}</jenkinsUrl>
    </jenkins.model.JenkinsLocationConfiguration>
{% endif %}
  proxy.xml: |
    <?xml version='1.0' encoding='UTF-8'?>
{% if proxy_host | default(False) or squid_address is defined %}
    <proxy>
{% if proxy_host | default(False) %}
      <name>{{ proxy_host }}</name>
      <port>{{ proxy_port | default('3128') }}</port>
{% else %}
      <name>{{ squid_address | urlsplit('hostname') }}</name>
      <port>{{ squid_address | default('port') }}</port>
{% endif %}
      <noProxyHost>*.svc.{{ cluster_domain }}
    *.{{ namespace }}.svc.{{ cluster_domain }}
    *.{{ namespace }}.svc
    *.{{ namespace }}
    *.svc.{{ cluster_domain }}
    *.svc
    *.{{ cluster_domain }}
    *.{{ root_domain }}
{% if (no_proxy | default([])) | length > 0 %}
{% for entry in no_proxy %}
    {{ entry }}
{% endfor %}
{% endif %}
    *.local</noProxyHost>
      <secretPassword></secretPassword>
      <testUrl>{{ proxy_test_url | default('http://registry.npmjs.org') }}</testUrl>
    </proxy>
{% endif %}
